import { CheckboxSOP } from '../../libappsop/checkboxsop';
import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogDummy } from '../dialogs/dialog.dummy';

export class FormProductionPlanDetails extends FormSOP {
  public static readonly title = 'Production plan details';
  public cbFilterByProductionPlanning = new CheckboxSOP('CheckboxToggleButton');
  public listProductionPlanDetails = new ListProductionPlanDetails();

  public constructor() {
    super('FormProductionPlanDetails');
  }
}

export class ListProductionPlanDetails extends ListSOP<DialogDummy, ListProductionPlanningDetailsColumn> {
  public static readonly title = 'Production plan details';

  public constructor() {
    super('ListNewSupply', new DialogDummy());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { Unit: '', Operation: '', Start: '' };
  }
}

// Although form (and not dialog), we create the interface so that spec script can use for step description (e.g calling StepDialog related method to use in "it")
export interface FormProductionPlanningDetailsFields {
  ToggleFilterByProductionPlanning: boolean;
}

export interface ListProductionPlanningDetailsColumn {
  Unit?: string;
  Routing?: string;
  Step?: string;
  Operation?: string;
  Start?: string;
  UnitOfMeasure?: string;
  FeedbackQuantity?: string;
  Quantity?: string;
}
